//---------------------------------------------------------------------------
#include <cppunit/ui/text/TestRunner.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/Exception.h>
#include <cppunit/SourceLine.h>
#include "TestSimManager.h"
#include "TestLightFilter.h"
#include "TestSpatialDispersal.h"
#include "TestEstablishment.h"
#include "TestGermination.h"
#include "TestNonSpatialDispersal.h"
#include "TestModelMath.h"
#include "TestGrids.h"
#include "TestSeedPredation.h"
#include "TestIsotropicDisperse.h"
#include "TestSeedStochasticity.h"
#include "TestSubstrate.h"
#include "TestNZSubstrate.h"
#include "TestPlot.h"
#include "TestNZEstablishment.h"
#include "TestStochasticMort.h"
#include "TestTreePopulation.h"
#include "TestTreeRemover.h"
#include "TestMortalityOrg.h"
#include "TestMortality.h"
#include "TestHarvest.h"
#include "TestEpisodicMortality.h"
#include "TestPlanting.h"
#include "TestTree.h"
#include "TestGrowthOrg.h"
#include "TestAbsoluteGrowth.h"
#include "TestRelativeGrowth.h"
#include "TestGrowthHeightIncrementer.h"
#include "TestNciGrowth.h"
#include "TestLogisticGrowth.h"
#include "TestSimpleLinearGrowth.h"
#include "TestShadedLinearGrowth.h"
#include "TestSizeDepLogisticGrowth.h"
#include "TestLognormalGrowth.h"
#include "TestLightOrg.h"
#include "TestWeibullSnagMort.h"
#include "TestLightBehaviors.h"
#include "TestStorm.h"
#include "TestStormDamageApplier.h"
#include "TestNCIMort.h"
#include "TestPuertoRicoEstablishment.h"
#include "TestVolumeCalculator.h"
#include "TestTreePopulation2.h"
#include "TestGLIMap.h"
#include "TestDimensionAnalysis.h"
#include "TestGapLight.h"
#include "TestDoubleMMRelGrowth.h"
#include "TestResourceMortality.h"
#include "TestStochasticGapGrowth.h"
#include "TestCompetitionMortality.h"
#include "TestDensitySelfThinning.h"
#include "TestBoleVolumeCalculator.h"
#include "Messages.h"
#include <iostream.h>
//---------------------------------------------------------------------------

int main(int argc, char * argv[])
{
  try {
//  CppUnit::TextUi::TestRunner runner;
//  runner.addTest(TestSimManager::suite());
//  runner.addTest(TestLightFilter::suite());
//  runner.run();

//  clTestModelMath *p_oMathTest = new clTestModelMath();
//  p_oMathTest->TestMath();
//  cout << "TestMath test successful.\n";
//  cout.flush();
//  delete p_oMathTest;

//  TestSimManager *p_oSimManagerTest = new TestSimManager();
//  p_oSimManagerTest->TestDoSetup1();
//  p_oSimManagerTest->TestDoSetup2();
//  p_oSimManagerTest->TestDoSetup3();
//  cout << "TestSimManager test successful.\n";
//  cout.flush();
//  delete p_oSimManagerTest;

//  TestLightFilter *p_oFilter = new TestLightFilter();
//  p_oFilter->TestLightFiltering();
//  cout << "TestLightFiltering test successful.\n";
//  cout.flush();
//  delete p_oFilter;

//  clTestSpatialDispersal *p_oDispersal = new clTestSpatialDispersal();
//  p_oDispersal->TestSpatialDisperse();
//  cout << "TestSpatialDispersal test successful.\n";
//  delete p_oDispersal;

//  clTestEstablishment *p_oEstablishment = new clTestEstablishment();
//  p_oEstablishment->TestEstablishment1();
//  p_oEstablishment->TestEstablishment2();
//  cout << "TestEstablishment test successful.";
//  delete p_oEstablishment;

//  clTestGermination *p_oGermination = new clTestGermination();
//  p_oGermination->TestGermination();
//  cout << "TestGermination test successful.";
//  delete p_oGermination;

//  clTestNonSpatialDispersal *p_oNonSpatialDispersal = new clTestNonSpatialDispersal();
//  p_oNonSpatialDispersal->TestNonSpatialDispersal();
//  cout << "TestNonSpatialDispersal test successful.";
//  delete p_oNonSpatialDispersal;

//  clTestGrids *p_oGridTest = new clTestGrids();
//  p_oGridTest->TestGrids();
//  cout << "TestGrids test was successful.";
//  delete p_oGridTest;

//  clTestSeedPredation *p_oPredation = new clTestSeedPredation();
//  p_oPredation->TestSeedPredation();
//  cout << "TestSeedPredation test was successful.";
//  delete p_oPredation;

//  clTestSeedStochasticity *p_oDisperse = new clTestSeedStochasticity();
//  p_oDisperse->TestGotAllDisperseObjects();
//  cout << "TestSeedStochasticity test was successful.";
//  delete p_oDisperse;

//  clTestSubstrate *p_oSubstrate = new clTestSubstrate();
//  p_oSubstrate->ProduceDecayGraphs();
//  p_oSubstrate->TestSubstrate();
//  cout << "TestSubstrate test was successful.";
//  delete p_oSubstrate;





  //*****************************
  // This test failed
  //*****************************
//  clTestNZSubstrate *p_oSubstrate = new clTestNZSubstrate();
//  p_oSubstrate->TestNZSubstrate();
//  cout << "TestNZSubstrate test was successful.";
//  delete p_oSubstrate;





//  clTestPlot *p_oPlot = new clTestPlot();
//  p_oPlot->TestPlot();
//  cout << "TestPlot test was successful.";
//  delete p_oPlot;

//  clTestNZEstablishment *p_oEstablishment = new clTestNZEstablishment();
//  p_oEstablishment->TestNZEstablishment();
//  cout << "TestNZEstablishment test was successful.";
//  delete p_oEstablishment;

//  clTestStochasticMort *p_oMort = new clTestStochasticMort();
//  p_oMort->TestStochasticMortality();
//  cout << "TestStochasticMortality test was successful.";
//  delete p_oMort;

//  clTestTreePopulation *p_oTest = new clTestTreePopulation();
//  p_oTest->TestTreePopulation();
//  cout << "TestTreePopulation test was successful.";
//  delete p_oTest;

//  clTestMortalityOrg *p_oTest = new clTestMortalityOrg();
//  p_oTest->TestMortalityOrg();
//  cout << "TestMortalityOrg test was successful.";
//  delete p_oTest;

//  clTestTreeRemover *p_oTest = new clTestTreeRemover();
//  p_oTest->TestTreeRemover();
//  cout << "TestTreeRemover test was successful.";
//  delete p_oTest;

//  clTestMortality *p_oTest = new clTestMortality();
//  p_oTest->TestMortality();
//  cout << "TestMortality test was successful.";
//  delete p_oTest;

//  clTestHarvest *p_oTest = new clTestHarvest();
//  p_oTest->TestHarvest();
//  cout << "TestHarvest test was successful.";
//  delete p_oTest;

//  clTestPlanting *p_oTest = new clTestPlanting();
//  p_oTest->TestPlanting();
//  cout << "TestPlanting test was successful.";
//  delete p_oTest;






  //*****************************
  // This test failed
  //*****************************
//  clTestEpisodicMortality *p_oTest = new clTestEpisodicMortality();
//  p_oTest->TestEpisodicMortality();
//  cout << "TestEpisodicMortality test was successful.";
//  delete p_oTest;






//  clTestTree *p_oTest = new clTestTree();
//  p_oTest->TestTree();
//  cout << "TestTree test was successful.";
//  delete p_oTest;

//  clTestGrowthOrg *p_oTest = new clTestGrowthOrg();
//  p_oTest->TestGrowthOrg();
//  cout << "TestGrowthOrg test was successful.";
//  delete p_oTest;

//  clTestAbsoluteGrowth *p_oTest = new clTestAbsoluteGrowth();
//  p_oTest->TestAbsoluteGrowth();
//  cout << "TestAbsoluteGrowth test was successful.";
//  delete p_oTest;

//  clTestRelativeGrowth *p_oTest = new clTestRelativeGrowth();
//  p_oTest->TestRelativeGrowth();
//  cout << "TestRelativeGrowth test was successful.";
//  delete p_oTest;

//  clTestGrowthHeightIncrementer *p_oTest = new clTestGrowthHeightIncrementer();
//  p_oTest->TestGrowthHeightIncrementer();
//  cout << "TestGrowthHeightIncrementer test was successful.";
//  delete p_oTest;

//  clTestNciGrowth *p_oTest = new clTestNciGrowth();
//  p_oTest->TestNciGrowth();
//  cout << "TestNciGrowth test was successful.";
//  delete p_oTest;

//  clTestLogisticGrowth *p_oTest = new clTestLogisticGrowth();
//  p_oTest->TestLogisticGrowth();
//  cout << "TestLogisticGrowth test was successful.";
//  delete p_oTest;

//  clTestSimpleLinearGrowth *p_oTest = new clTestSimpleLinearGrowth();
//  p_oTest->TestSimpleLinearGrowth();
//  cout << "TestSimpleLinearGrowth test was successful.";
//  delete p_oTest;

//  clTestShadedLinearGrowth *p_oTest = new clTestShadedLinearGrowth();
//  p_oTest->TestShadedLinearGrowth();
//  cout << "TestShadedLinearGrowth test was successful.";
//  delete p_oTest;

//  clTestSizeDepLogisticGrowth *p_oTest = new clTestSizeDepLogisticGrowth();
//  p_oTest->TestSizeDepLogisticGrowth();
//  cout << "TestSizeDepLogisticGrowth test was successful.";
//  delete p_oTest;

//  clTestLognormalGrowth *p_oTest = new clTestLognormalGrowth();
//  p_oTest->TestLognormalGrowth();
//  cout << "TestLognormalGrowth test was successful.";
//  delete p_oTest;

//  clTestLightOrg *p_oTest = new clTestLightOrg();
//  p_oTest->TestLightOrg();
//  cout << "TestLightOrg test was successful.";
//  delete p_oTest;

//  clTestWeibullSnagMort *p_oTest = new clTestWeibullSnagMort();
//  p_oTest->TestWeibullSnagMort();
//  cout << "TestWeibullSnagMort test was successful.";
//  delete p_oTest;

//  clTestStorm *p_oTest = new clTestStorm();
//  p_oTest->TestStorm();
//  cout << "TestStorm test was successful.";
//  delete p_oTest;

//  clTestLightBehaviors *p_oTest = new clTestLightBehaviors();
//  p_oTest->TestLight();
//  cout << "TestLightBehaviors test was successful.";
//  delete p_oTest;

//  clTestStormDamageApplier *p_oTest = new clTestStormDamageApplier();
//  p_oTest->TestStormDamageApplier();
  //p_oTest->MakeGraphs();
//  cout << "TestStormDamageApplier test was successful.";
//  delete p_oTest;

//  clTestNCIMort *p_oTest = new clTestNCIMort();
//  p_oTest->TestNCIMort();
//  cout << "TestNCIMort test was successful.";
//  delete p_oTest;

//  clTestPuertoRicoEstablishment *p_oTest = new clTestPuertoRicoEstablishment();
//  p_oTest->TestPuertoRicoEstablishment();
//  cout << "TestPuertoRicoEstablishment test was successful.";
//  delete p_oTest;

//  clTestVolumeCalculator *p_oTest = new clTestVolumeCalculator();
//  p_oTest->TestVolumeCalculator();
//  cout << "TestVolumeCalculator test was successful.";
//  delete p_oTest;

//  clTestTreePopulation2 *p_oTest = new clTestTreePopulation2();
//  p_oTest->TestTreePopulation();
//  cout << "TestTreePopulation2 test was successful.";
//  delete p_oTest;

//  clTestGLIMap *p_oTest = new clTestGLIMap();
//  p_oTest->TestGLIMap();
//  cout << "TestGLIMap test was successful.";
//  delete p_oTest;

//  clTestDimensionAnalysis *p_oTest = new clTestDimensionAnalysis();
//  p_oTest->TestDimensionAnalysis();
//  cout << "TestDimensionAnalysis test was successful.";
//  delete p_oTest;

//  clTestCompetitionMortality *p_oTest = new clTestCompetitionMortality();
//  p_oTest->TestMortality();
//  cout << "TestCompetitionMortality test was successful.";
//  delete p_oTest;

//  clTestGapLight *p_oTest = new clTestGapLight();
//  p_oTest->TestGapLight();
//  cout << "TestGapLight test was successful.";
//  delete p_oTest;

//  clTestDoubleMMRelGrowth *p_oTest = new clTestDoubleMMRelGrowth();
//  p_oTest->TestDoubleMMRelGrowth();
//  cout << "TestDoubleMMRelGrowth test was successful.";
//  delete p_oTest;

//  clTestResourceMortality *p_oTest = new clTestResourceMortality();
//  p_oTest->TestResourceMortality();
//  cout << "TestResourceMortality test was successful.";
//  delete p_oTest;

//  clTestStochasticGapGrowth *p_oTest = new clTestStochasticGapGrowth();
//  p_oTest->TestStochasticGapGrowth();
//  cout << "TestStochasticGapGrowth test was successful.";
//  delete p_oTest;

//  clTestDensitySelfThinning *p_oTest = new clTestDensitySelfThinning();
//  p_oTest->TestDensitySelfThinning();
//  cout << "TestDensitySelfThinning test was successful.";
//  delete p_oTest;

  clTestBoleVolumeCalculator *p_oTest = new clTestBoleVolumeCalculator();
  p_oTest->TestBoleVolumeCalculator();
  cout << "TestBoleVolumeCalculator test was successful.";
  delete p_oTest;

  return 0;
  } catch (modelErr err) {
    cout << "Exception thrown by " << err.cFunction << ":  " << err.cMoreInfo;
  } catch (CppUnit::Exception err) {
    cout << "Exception thrown - message: " << err.what() << " in file "
         << err.sourceLine().fileName() << " at line "
         << err.sourceLine().lineNumber() << ".";

  } catch (...) {
    cout << "Exception thrown.";
  }
}
//---------------------------------------------------------------------------
