//---------------------------------------------------------------------------
// TestSeedStochasticity
//---------------------------------------------------------------------------
#if !defined(TestSeedStochasticity_H)
  #define TestSeedStochasticity_H

#include <cppunit/TestFixture.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>

class clGridBase;

  /**
   This class tests seed stochasticity.  Actual stochastic seed distributions
   cannot be tested - those must be done visually.
   */
class clTestSeedStochasticity : public CppUnit::TestFixture
{

  public:

  /**
  * This makes sure that all disperse objects are found.  WriteXMLFile1() is
  * used to create the test file, with five species assigned to each of the
  * five different disperse object types.  After the behaviors have run, this
  * verifies that there are seeds of each species present.
  */
  TestGotAllDisperseObjects();

  private:

  /**
  * Writes a parameter file with five species, one for each disperse object
  * type.
  * @return Filename written.
  */
  char * WriteXMLFile1();


};
//---------------------------------------------------------------------------
#endif // TestSeedStochasticity_H
